
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>设计模式之禅之代理模式 / iVAN</title>

    <meta name="description" content="设计模式之禅之代理模式 jdk的动态代理的条件: ===&gt;要实现动态代理的首要条件是:被代理类必须实现一个接口,回想一下前面的分析吧.当然了,现在也有很多技术如CGLIB可以实现不需要接口也可以实现动态代理的方式.   动态代理的应用 代理模式应用得非常广泛,大到一个系统框架.企业平台,小到代码片段.事务处理,稍不留意就用到代理模式.可能该模式是大家接触最多的模式,而且有了AOP大家写代理就更加简单了,有类似Spring AOP和AspectJ这样非常优秀的工具,拿来主义即可!不过,大家可以看看源代码,特别是调试 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">设计模式之禅之代理模式</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>jdk的动态代理的条件：</p>
<p>===&gt;要实现动态代理的首要条件是:被代理类必须实现一个接口,回想一下前面的分析吧。当然了,现在也有很多技术如CGLIB可以实现不需要接口也可以实现动态代理的方<br />式。</p>
<p> </p>
<p>动态代理的应用</p>
<p>代理模式应用得非常广泛,大到一个系统框架、企业平台,小到代码片段、事务处理,稍不留意就用到代理模式。可能该模式是大家接触最多的模式,而且有了AOP大家写代理就<br />更加简单了,有类似Spring AOP和AspectJ这样非常优秀的工具,拿来主义即可!不过,大家可以看看源代码,特别是调试时,只要看到类似$Proxy0这样的结构,你就应该知道这是一<br />个动态代理了。友情提醒,在学习AOP框架时,弄清楚几个名词就成:切面(Aspect)、切入点(JoinPoint)、通知(Advice)、织入(Weave)就足够了,理解了这几个名词,应用时你<br />就可以游刃有余了!</p>
<p> </p>
<p>（1）普通代理，代理和被代理实现相同的接口。代理者拥有被代理者的引用</p>
<p>一：接口</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg"></p>
<pre> 1 package com.nonbank.commons.aop;
 2 /**
 3  * 接口类
 4  * @author sxf
 5  *
 6  */
 7 public interface Player {
 8     /**
 9      *打怪升级
10      */
11     public void killBoss();
12 }</pre>
<p>View Code</p>
<p>二：被代理者</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg"></p>
<pre> 1 package com.nonbank.commons.aop;
 2 /**
 3  * 真实玩家
 4  * @author sxf
 5  *
 6  */
 7 public class GamePlayer implements Player{
 8
 9     @Override
10     public void killBoss() {
11         System.out.println("GamePlayer.killBoss()=======&gt;打死一个boss");
12     }
13
14
15
16 }</pre>
<p>View Code</p>
<p>三：代理者</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg"></p>
<pre> 1 package com.nonbank.commons.aop;
 2
 3 import org.drools.rule.builder.dialect.java.parser.JavaParser.parExpression_return;
 4
 5 /**
 6  * 代理玩家
 7  * @author sxf
 8  *
 9  */
10 public class GamePlayer_Poxy implements Player {
11
12
13
14     /**
15      * 被代理的玩家
16      */
17     private Player player;
18
19
20      public GamePlayer_Poxy() {
21
22     }
23
24      public GamePlayer_Poxy(GamePlayer player) {
25         this.player=player;
26     }
27
28     @Override
29     public void killBoss() {
30         System.out.println("GamePlayer_Poxy.killBoss()===&gt;代理实现的一些增强前");
31         player.killBoss();
32         System.out.println("GamePlayer_Poxy.killBoss()===&gt;代理实现的一些增强后");
33
34     }
35
36
37 }</pre>
<p>View Code</p>
<p>四：测试类</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg"></p>
<pre> 1 package com.nonbank.commons.aop;
 2
 3 public class AopTest {
 4
 5     public static void main(String[] args) {
 6
 7     }
 8
 9     /**
10      * 普通的静态代理
11      */
12     public static void test01(){
13         //被代理角色
14         GamePlayer gamePlayer=new GamePlayer();
15         //代理角色
16         GamePlayer_Poxy poxy=new GamePlayer_Poxy(gamePlayer);
17         //代理角色持有被代理角色的引用，代理和被代理实现相同的接口
18         poxy.killBoss();
19     }
20
21 }</pre>
<p>View Code</p>
<p> </p>
<p>(2)动态代理，代理指定接口的实现</p>
<p>一：接口</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg"></p>
<pre> 1 package com.nonbank.commons.aop;
 2 /**
 3  * 动态代理，被代理的接口
 4  * @author sxf
 5  *
 6  */
 7 public interface Mlayer {
 8     /**
 9      * 打怪
10      * @param name
11      * @return
12      */
13     public String killBoss(String name);
14     /**
15      * 登陆
16      * @param name
17      * @param password
18      * @return
19      */
20     public String login(String name,String password);
21 }</pre>
<p>View Code</p>
<p>二：动态代理执行器，也就是在此处添加增强的实现类</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg"></p>
<pre> 1 package com.nonbank.commons.aop;
 2
 3 import java.lang.reflect.InvocationHandler;
 4 import java.lang.reflect.Method;
 5 /**
 6  * 动态代理的增强类，实现代理的类
 7  * @author sxf
 8  *
 9  */
10 public class MyInvocationHandler implements InvocationHandler{
11     /**
12      * 被代理的真实对象
13      */
14     private Object target;
15
16
17
18     public MyInvocationHandler() {
19
20     }
21
22     public MyInvocationHandler(Object target){
23         this.target=target;
24     }
25
26     @Override
27     public Object invoke(Object proxy, Method method, Object[] args)throws Throwable {
28         System.out.println("MyInvocationHandler.invoke()===&gt;动态代理实现了一些增强前..................");
29         Object object=method.invoke(this.target, args);
30         System.out.println("MyInvocationHandler.invoke()===&gt;动态代理实现了一些增强后..................");
31         return object;
32     }
33
34
35 }</pre>
<p>View Code</p>
<p>三：被代理者的实现类</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg"></p>
<pre> 1 package com.nonbank.commons.aop;
 2 /**
 3  * 动态代理被代理者
 4  * @author sxf
 5  *
 6  */
 7 public class SxfGamePlayer  implements Mlayer{
 8
 9
10     @Override
11     public String killBoss(String name){
12         System.out.println("SxfGamePlayer.killBoss()要打的怪物名字是===&gt;"+name);
13         return name+"这个怪物被打死了";
14     }
15
16     @Override
17     public String login(String name, String password) {
18         System.out.println("SxfGamePlayer.login()登陆的名字是===&gt;name=["+name+"]password=["+password+"]");
19         return "sxf你登陆成功了";
20     }
21
22
23
24
25 }</pre>
<p>View Code</p>
<p>四：测试类</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg"></p>
<pre> 1 package com.nonbank.commons.aop;
 2
 3 import java.lang.reflect.Proxy;
 4
 5 public class AopTest {
 6
 7     public static void main(String[] args) {
 8         test02();
 9     }
10
11     /**
12      * 普通的静态代理
13      */
14     public static void test01(){
15         //被代理角色
16         GamePlayer gamePlayer=new GamePlayer();
17         //代理角色
18         GamePlayer_Poxy poxy=new GamePlayer_Poxy(gamePlayer);
19         //代理角色持有被代理角色的引用，代理和被代理实现相同的接口
20         poxy.killBoss();
21     }
22
23     /**
24      * 动态代理测试
25      */
26     public static void test02(){
27         //被代理对象的真实角色
28         SxfGamePlayer paGamePlayer=new SxfGamePlayer();
29         //生成代理执行的Ｈandler
30         MyInvocationHandler myInvocationHandler=new MyInvocationHandler(paGamePlayer);
31         //获取当前线程的类加载器
32         ClassLoader classLoader=paGamePlayer.getClass().getClassLoader();
33         //动态生成代理对象(当前线程的类加载器，当前被代理对象的所有接口，生成的代理执行的Handler)
34         Mlayer mylMlayer=(Mlayer) Proxy.newProxyInstance(paGamePlayer.getClass().getClassLoader(),paGamePlayer.getClass().getInterfaces(), myInvocationHandler);
35         //执行被代理的方法
36         String result=mylMlayer.killBoss("王者荣耀之暴君");
37         System.out.println("AopTest.test02()killBoss执行结果==&gt;"+result);
38
39         String resultSt=mylMlayer.login("王者孙悟空", "12345");
40         System.out.println("AopTest.test02()login执行结果===&gt;"+resultSt);
41
42         /**
43          * MyInvocationHandler.invoke()===&gt;动态代理实现了一些增强前..................
44             SxfGamePlayer.killBoss()要打的怪物名字是===&gt;王者荣耀之暴君
45             MyInvocationHandler.invoke()===&gt;动态代理实现了一些增强后..................
46             AopTest.test02()killBoss执行结果==&gt;王者荣耀之暴君这个怪物被打死了
47             MyInvocationHandler.invoke()===&gt;动态代理实现了一些增强前..................
48             SxfGamePlayer.login()登陆的名字是===&gt;name=[王者孙悟空]password=[12345]
49             MyInvocationHandler.invoke()===&gt;动态代理实现了一些增强后..................
50             AopTest.test02()login执行结果===&gt;sxf你登陆成功了
51         *
52          */
53     }
54 }</pre>
<p>View Code</p>
<p> </p>
<p>扩展：对生成的代理类进行再次代理</p>
<p>再次代理的增强</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg"></p>
<pre> 1 package com.nonbank.commons.aop;
 2
 3 import java.lang.reflect.InvocationHandler;
 4 import java.lang.reflect.Method;
 5 /**
 6  * 对第一层代理类进行第二次代理
 7  * @author sxf
 8  *
 9  */
10 public class MyInvocationHandler2 implements InvocationHandler{
11
12     private Object object;
13
14     public MyInvocationHandler2(Object object){
15         this.object=object;
16     }
17
18     @Override
19     public Object invoke(Object proxy, Method method, Object[] args)
20             throws Throwable {
21         System.out.println("MyInvocationHandler2.invoke()sxfffffffffffffffffffffffffffffffstart");
22         Object objectd=method.invoke(this.object,args);
23         System.out.println("MyInvocationHandler2.enclosing_method()sxffffffffffffffffffffend");
24
25         return objectd;
26     }
27
28
29
30 }</pre>
<p>View Code</p>
<p>再次代理的实现</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg"></p>
<pre> 1 package com.nonbank.commons.aop;
 2
 3 import java.lang.reflect.Proxy;
 4 import java.sql.Connection;
 5 import java.sql.DriverManager;
 6 import java.sql.SQLException;
 7
 8 public class AopTest {
 9
10     public static void main(String[] args) {
11         test02();
12     }
13
14     /**
15      * 普通的静态代理
16      */
17     public static void test01(){
18         //被代理角色
19         GamePlayer gamePlayer=new GamePlayer();
20         //代理角色
21         GamePlayer_Poxy poxy=new GamePlayer_Poxy(gamePlayer);
22         //代理角色持有被代理角色的引用，代理和被代理实现相同的接口
23         poxy.killBoss();
24     }
25
26     /**
27      * 动态代理测试
28      */
29     public static void test02(){
30         //被代理对象的真实角色
31         SxfGamePlayer paGamePlayer=new SxfGamePlayer();
32         //生成代理执行的Ｈandler
33         MyInvocationHandler myInvocationHandler=new MyInvocationHandler(paGamePlayer);
34         //获取当前线程的类加载器
35         ClassLoader classLoader=paGamePlayer.getClass().getClassLoader();
36         //动态生成代理对象(当前线程的类加载器，当前被代理对象的所有接口，生成的代理执行的Handler)
37         Mlayer mylMlayer=(Mlayer) Proxy.newProxyInstance(paGamePlayer.getClass().getClassLoader(),paGamePlayer.getClass().getInterfaces(), myInvocationHandler);
38
39         MyInvocationHandler2 myInvocationHandler2=new MyInvocationHandler2(mylMlayer);
40         Mlayer mylMlayer2=(Mlayer) Proxy.newProxyInstance(paGamePlayer.getClass().getClassLoader(),paGamePlayer.getClass().getInterfaces(), myInvocationHandler2);
41         //执行被代理的方法
42         String result=mylMlayer2.killBoss("王者荣耀之暴君");
43         System.out.println("AopTest.test02()killBoss执行结果==&gt;"+result);
44
45         String resultSt=mylMlayer2.login("王者孙悟空", "12345");
46         System.out.println("AopTest.test02()login执行结果===&gt;"+resultSt);
47
48         /**
49          * MyInvocationHandler2.invoke()sxfffffffffffffffffffffffffffffffstart
50             MyInvocationHandler.invoke()===&gt;动态代理实现了一些增强前..................
51             SxfGamePlayer.killBoss()要打的怪物名字是===&gt;王者荣耀之暴君
52             MyInvocationHandler.invoke()===&gt;动态代理实现了一些增强后..................
53             MyInvocationHandler2.enclosing_method()sxffffffffffffffffffffend
54             AopTest.test02()killBoss执行结果==&gt;王者荣耀之暴君这个怪物被打死了
55             MyInvocationHandler2.invoke()sxfffffffffffffffffffffffffffffffstart
56             MyInvocationHandler.invoke()===&gt;动态代理实现了一些增强前..................
57             SxfGamePlayer.login()登陆的名字是===&gt;name=[王者孙悟空]password=[12345]
58             MyInvocationHandler.invoke()===&gt;动态代理实现了一些增强后..................
59             MyInvocationHandler2.enclosing_method()sxffffffffffffffffffffend
60             AopTest.test02()login执行结果===&gt;sxf你登陆成功了
61
62         *
63          */
64     }
65
66
67     public static void test03() throws SQLException{
68         Connection connection= DriverManager.getConnection("连接URL", "用户名", "密码");
69         //关闭自动提交
70         connection.setAutoCommit(false);
71         //该连接所有操作进行提交提交
72         connection.commit();
73         //该链接所有操作进行回滚
74         connection.rollback();
75         //connection.rollback(savepoint);
76         //spring的事务管理器，在aop编程（动态代理）的增强方法中实现事务管理的编码，可以实现提交和回滚
77
78     }
79
80
81     public static void springInvoker(){
82
83     }
84 }</pre>
<p>View Code</p>
<p> </p>
<p> </p>
<p> </p>
<p> </p>
<p>三：spring的事务管理，就是基于动态代理aop编程实现事务管理，声明式事务编程，编码式事务编程</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg"></p>
<pre> 1 public static void test03() throws SQLException{
 2         Connection connection= DriverManager.getConnection("连接URL", "用户名", "密码");
 3         //关闭自动提交
 4         connection.setAutoCommit(false);
 5         //该连接所有操作进行提交提交
 6         connection.commit();
 7         //该链接所有操作进行回滚
 8         connection.rollback();
 9         //connection.rollback(savepoint);
10         //spring的事务管理器，在aop编程（动态代理）的增强方法中实现事务管理的编码，可以实现提交和回滚
11
12     }</pre>
<p>View Code</p>
<p> </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 19:07:17</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/static/" title="static">static</a>, <a href="https://www.iamivan.net/tag/void/" title="void">void</a>, <a href="https://www.iamivan.net/tag/code/" title="code">code</a>, <a href="https://www.iamivan.net/tag/test/" title="test">test</a>, <a href="https://www.iamivan.net/tag/view/" title="view">view</a>, <a href="https://www.iamivan.net/tag/login/" title="login">login</a>, <a href="https://www.iamivan.net/tag/aop/" title="aop">aop</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>设计模式之禅之代理模式的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYjDDep.html" rel="bookmark">设计模式（十一）代理模式Proxy（结构型）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				设计模式(十一)代理模式Proxy(结构型)    1.概述        因为某个对象消耗太多资源,而且你的代码并不是每个逻辑路径都需要此对象, 你曾有过延迟创建对象的想法吗 ( if和else就是不同的两条逻辑路径) ? 你有想过限制访问某个对象,也就是说,提供一组方法给普通用户,特别方法给管理员用户?以上两种需求都非常类似,并且都需要解决一个更大的问题:你如何提供一致的接口给某个对象让它可以改变其内部功能,或者是从来不存在的功能? 可以通过引入一个新的对象,来实现对真实对象的操作或者将新的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MY2r7Vp.html" rel="bookmark">传统设计模式（十一）代理模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				所谓的代理,就是代表某个真实的对象.在这个设计模式中,代理可以假装自己是远程对象,但其实只是一个中间角色.客户对象所作的就像是在做远程方法调用,但其实只是调用本地资源中得&quot;代理&quot;对象上得方法,再由代理处理所有网络通信的底层细节. 其实其实项目实例神马的 根本就没必要了 看一下Web Service的调用方式大家也许就明白了,它会在客户端生成一个代理类 - - 已经很完美的诠释了代理模式这个概念 虫子放下水 直接拿以前监控项目中客户端采集的代理方法了 --_____-- 服务器端 [We			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bB1q7oz.html" rel="bookmark">C&plus;&plus;设计模式编程中proxy代理模式的使用实例&lowbar;C 语言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				代理模式典型的结构图为: 实际上,代理模式的想法非常简单. 代理模式的实现: 完整代码示例(code):代理模式的实现很简单,这里为了方便初学者的学习和参考,将给出完整的实现代码(所有代码采用 C++实现,并在 VC 6.0 下测试运行). 代码片断 1:Proxy.h //Proxy.h #ifndef _PROXY_H_ #define _PROXY_H_ class Subject{ public: virtual ~Subject(); virtual void Request() =			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDkP5Bp.html" rel="bookmark">详解设计模式中的proxy代理模式及在Java程序中的实现&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.代理模式定义 给某个对象提供一个代理对象,并由代理对象控制对于原对象的访问,即客户不直接操控原对象,而是通过代理对象间接地操控原对象. 著名的代理模式的例子就是引用计数(reference counting): 当需要一个复杂对象的多份副本时, 代理模式可以结合享元模式以减少存储器的用量.典型做法是创建一个复杂对象以及多个代理者, 每个代理者会引用到原本的对象.而作用在代理者的运算会转送到原本对象.一旦所有的代理者都不存在时, 复杂对象会被移除. 要理解代理模式很简单,其实生活当中就存在代理			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvGZ68p.html" rel="bookmark">设计模式-深入理解各种代理模式（2）通俗代码版</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				3&gt;多代理模式:提高或增强代理的其他业务,如:拦截.过滤等 public interface IGamePlayer { //登录游戏public void login(String user,String password); //杀怪,这是网络游戏的主要特色public void killBoss(); //升级public void upgrade(); } --- public interface IProxy {//计算费用public void count(); } --- publ			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBZdDJb.html" rel="bookmark">Java设计模式（八）----代理模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				代理模式 1.生活中: 代理就是一个人或者一个组织代表其他人去做一件事的现实生活中的.在一些情况下,一个客户不想或者不能够直接引用一个对象,而代理对象可以在客户端和目标对象之间起到中介的作用. 2.官方: 代理模式是对象的结构模式.代理模式给某一个对象提供一个代理对象,并由代理对象控制对原对象的引用 一.静态代理 类图结构如下 在代理模式中的角色: ●抽象主题角色:声明了目标对象和代理对象的共同接口,这样一来在任何可以使用目标对象的地方都可以使用代理对象. ●真实主题角色:定义了代理对象所代表的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MW258mb.html" rel="bookmark">设计模式系列之五：代理模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				代理模式 代理模式的定义很简单:给某一对象提供一个代理对象,并由代理对象控制对原对象的引用. 代理模式的结构 有些情况下,一个客户不想活着不能够直接引用一个对象,可以通过代理对象在客户端和目标对象之间起到中介作用.代理模式中的角色有: 1.抽象对象角色 声明了目标对象和代理对象的共同接口,这样一来在任何可以使用目标对象的地方都可以使用代理对象 2.目标对象角色 定义了代理对象所代表的目标对象 3.代理对象角色 代理对象内部含有目标对象的引用,从而可以在任何时候操作目标对象:代理对象提供一个与目标			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnRKX0p.html" rel="bookmark">设计模式-深入理解各种代理模式（1）通俗代码版</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1&gt;普通代理模式(有益于扩展开发),对代理者进行封装真实角色 public interface IGamePlayer { //登录游戏public void login(String user,String password); //杀怪,这是网络游戏的主要特色public void killBoss(); //升级public void upgrade(); } --- public class GamePlayer implements IGamePlayer {private Strin			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pP2JV8b.html" rel="bookmark">设计模式详解之代理模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				代理模式(Proxy):其实每个模式名称就表明了该模式的作用,代理模式就是多一个代理类出来,替原对象进行一些操作,比如我们在租房子的时候回去找中介,为什么呢?因为你对该地区房屋的信息掌握的不够全面,希望找一个更熟悉的人去帮你做,此处的带你就是这个意思.再如我们有的时候打官司,我们需要请律师,因为律师在法律方面有专长,可以替我们进行操作,表达我们的想法.先来看看关系图: 根据上文的阐述,代理模式就比较容易的理解了,我们看下代码: public interface Sourceable { publ			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkGBOp.html" rel="bookmark" class="title">网络子系统14&lowbar;邻居子系统通用接口</a>
					<div>
						//创建一个新的邻居项 //参考 深入理解linux网络技术内幕 // 1.邻居子系统为具体的邻居协议,提供通用的功能接口 // 2.系统中所有的邻居协议被链接在neigh_tables链表中 //  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQvYZM.html" rel="bookmark" class="title">asp取动态表单中数据并写入xml文件&comma;用xsl显示</a>
					<div>
						xml|动态|数据|显示|xml   1.动态表单的界面,从csdn论坛上参考 &lt;html&gt;&lt;head&gt;&lt;title&gt;无标题文档&lt;/title&gt;&lt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LpdO76M.html" rel="bookmark" class="title">如何得到数据库中所有表字段及字段中文描述</a>
					<div>
						数据|数据库|中文 如何得到数据库中所有表字段及字段中文描述以下资料,通过csdn的一位师兄从SQL版主那得到:sql中SELECT (case when a.colorder=1 then d.na ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0borX3z.html" rel="bookmark" class="title">显示、隐藏win95任务栏</a>
					<div>
						Declare Function FindWindow Lib &quot;user32&quot; Alias &quot;FindWindowA&quot; _ (ByVal lpClassNam ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo678Bz.html" rel="bookmark" class="title">oracle cluster的物理配置要求及限制</a>
					<div>
						1.Oracle Clusterware supports up to 100 nodes in a cluster on configurations running Oracle Database ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62DAAM.html" rel="bookmark" class="title">开机故障应该解决方法</a>
					<div>
						1·开机提示&quot;DisketteBootFailure&quot; [故障表现]开机正常完成自检后,出现&quot;DisketteBootFailure&quot;提示信息,无法进入系统.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKdo5p.html" rel="bookmark" class="title">MySQL安装、配置、使用及JDBC链接</a>
					<div>
						  URL: http://dev.mysql.com/downloads/mysql/5.5.html#downloads 选择No thanks, juststart my download. m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPZwZz.html" rel="bookmark" class="title">Photoshop制作暖色调美女摄影图</a>
					<div>
						  最终效果图 图0 1.首先打开原图,然后复制一层.这是个好习惯,让我们在后面的调整中不至于损坏原图. 图1 2.下面我们就开始对图片进行调整,首先先提亮照片的整体颜色,当然人物不需要调整,要不然会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYnNWM.html" rel="bookmark" class="title">好照片轻松上手Raw格式处理</a>
					<div>
						Raw是数码相机的专用格式,可以称之为&quot;电子底片&quot;,是原始图像编码数据.Raw格式的照片记录了数码相机传感器原始信息和一些由相机所产生的元数据,包含了拍摄影像的锐度.饱和度.对比度 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBlWVz.html" rel="bookmark" class="title">visio 2007使用实例图文</a>
					<div>
						  Microsoft Office Visio 2007 帮助你创建具有专业外观的图表,以便理解.记录和分析信息.数据.系统和过程. 大多数图形软件程序依赖艺术技能.然而,在你使用 Visio 时, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7xGvb.html" rel="bookmark" class="title">php表单的数据传递-php中从表格中得到的数据怎么样运用到另一个文件中</a>
					<div>
						问题描述 php中从表格中得到的数据怎么样运用到另一个文件中 我想从表单中得到数据然后传到以下代码中的&quot;tu&quot; 代码如下: function getBoundary(){ var  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo71AEb.html" rel="bookmark" class="title">代码-android线程休眠&lpar;Thread&period;sleep&rpar;的问题</a>
					<div>
						问题描述 android线程休眠(Thread.sleep)的问题 我有这么一段代码,照理说运行结果应该是refreshTAG2变成&quot;刷新成功&quot;,Logcat输出&quot;刷新成 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1laexb.html" rel="bookmark" class="title">new-smsx&period;cab做web打印时没有调打印机</a>
					<div>
						问题描述 smsx.cab做web打印时没有调打印机 if (factory.object) { // -- basic features factory.printing.header = &quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Q3g7p.html" rel="bookmark" class="title">java-求解为何一直404，底层用的spring&plus;springmvc&plus;mybatis</a>
					<div>
						问题描述 求解为何一直404,底层用的spring+springmvc+mybatis 解决方案 你的url最后有.do ,那么你的web.xml中dispatcherServlet中是拦截.do 的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7jB0z.html" rel="bookmark" class="title">elasticsea&period;&period;&period;-如何把一个内容为json格式的文档添加到elasticsearch上？</a>
					<div>
						问题描述 如何把一个内容为json格式的文档添加到elasticsearch上? 如题,注意不是一条json噢.是整个文档,里面有很多行json. 解决方案 http://www.cnblogs.co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAkGZM.html" rel="bookmark" class="title">Qlik深度分析亚太地区八大城市生活成本</a>
					<div>
						文章讲的是Qlik深度分析亚太地区八大城市生活成本,根据基于Qlik Sense应用程序的分析结果,东京生活成本最高,香港.悉尼.新加坡紧随其后. 6月15日,Qlik推出了一款基于Qlik可视化分析 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94QPXb.html" rel="bookmark" class="title">javaweb-求大神帮忙解决。tomcat500错误，具体如下，万分感谢！！</a>
					<div>
						问题描述 求大神帮忙解决.tomcat500错误,具体如下,万分感谢!! type Exception report message description The server encountere ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKymZz.html" rel="bookmark" class="title">纯干货：深度学习实现之空间变换网络-part1</a>
					<div>
						更多深度文章,请关注云计算频道:https://yq.aliyun.com/cloud 我的&quot;深度学习论文实现&quot;系列的前三个博客将涵盖2016年由Google Deepmind的M ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWl8gAp.html" rel="bookmark" class="title">开发者的实用 Vim 插件（二）</a>
					<div>
						毫无疑问,Vim 是一个开箱即用并能够胜任编程任务的编辑器,但实际上是该编辑器中的插件帮你实现这些方便的功能.在 开发者的实用 Vim 插件(一),我们已经讨论两个编程相关的 Vim 插件--标签侧边 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYGOWp.html" rel="bookmark" class="title">关于C&plus;&plus;的友元函数实现在类的外部问题？</a>
					<div>
						问题描述 关于C++的友元函数实现在类的外部问题? #include&lt;iostream&gt; using namespace std; template&lt;typename T&gt; c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRxEZb.html" rel="bookmark" class="title">当当网年中庆第二波来袭千种童书49折</a>
					<div>
						进入6月,当当网年 中庆的让利举措可谓接二连三,继上周第一波图书音像全场满200返300和满100返150活动之后,日前当当网已启动年中庆第二波让利活动,除图书满99元立减19元以及新书&quot;买 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBg29kM.html" rel="bookmark" class="title">智慧化的体验，从侧面诠释了今年电博会&OpenCurlyDoubleQuote;万物互联智慧生活&rdquo;的主题</a>
					<div>
						7月11日,第十三届中国国际消费电子博览会(简称电博会)在青岛国际会展中心举行,现场不仅展出了行业最前沿.最高端的电子产品,还为观众带来了更具科 技感的智慧体验.其中,卡萨帝展出的一款能与燃气灶智能联 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4ePoqb.html" rel="bookmark" class="title">被各大巨头嫌弃的Twitter，还能有翻身的机会吗？</a>
					<div>
						在过去的12个月中,总部位于旧金山的Twitter股价累计下滑了35%.这家公司的股价在8月底曾跌至18.25美元,低于其2013年11月进行首次公开招股时26美元的发行价.这也让Twitter一直陷 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkvxZM.html" rel="bookmark" class="title">repeater实现相对应行的选中取消</a>
					<div>
						问题描述 各位大神,我有2个repeater,是相互嵌套的,如何让外层的repeater中的checkbox选中后相对应的里面的repeater中的checkbox也选中,是相对应的,不是所有的都选中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqL4wp.html" rel="bookmark" class="title">《社交网站界面设计（原书第2版）》&mdash;&mdash;3&period;3　登录</a>
					<div>
						3.3 登录 是什么 用户想要访问存储在主网站的个人信息或者应用程序(参见图3-9). 何时使用 个人数据需要存储或者需要针对具体的用户进行自定义或个性化. 网站是用户所产生的内容的知识库,并且用户提 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDkJEOp.html" rel="bookmark" class="title">Android利用方向传感器获得手机的相对角度实例说明&lowbar;Android</a>
					<div>
						1.android 的坐标系是如何定义x, y z 轴的 x轴的方向是沿着屏幕的水平方向从左向右,如果手机不是正方形的话,较短的边需要水平放置,较长的边需要垂直放置. Y轴的方向是从屏幕的左下角开始沿 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk7gJyp.html" rel="bookmark" class="title">快递企业多地爆仓变慢递 柴油荒等多因素导致</a>
					<div>
						摘要: 昨天,记者从申通.韵达等多家快递公司了解到,由于柴油荒而使货车无法及时加油等原因导致公司在浙江.广东等多地出现爆仓现象,送达时限被延长,甚至部分城市的递送服务被迫 昨天,记者从申通.韵达等多家 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrvYGjM.html" rel="bookmark" class="title">特朗普当选令硅谷恐惧焦虑：多位大佬公开反对他</a>
					<div>
						导语:彭博社今天撰文称,与希拉里相比,特朗普在很多政策上的观点都不够明确,因此令硅谷陷入迷茫. 以下为文章全文: 唐纳德·特朗普(Donald Trump)在美国总统大选中爆冷胜出在硅谷引发了广泛的绝 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6qwDXb.html" rel="bookmark" class="title">labview和mapx5&period;0的开发</a>
					<div>
						问题描述 labview和mapx5.0的基本功能实现了,现在我想把带有经纬度坐标的数据显示在图中,应该怎么实现呢 解决方案 解决方案二:怎么没人回应??					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeLZlxp.html" rel="bookmark" class="title">日本佳丽宝再曝白斑丑闻新增受害者4千人</a>
					<div>
						日本知名化妆品佳丽宝再曝质量问题.日本共同社消息,佳丽宝近日宣布,截至9月29日,使用该公司美白化妆品后出现白斑症状的受害者新增4000人,受害者总人数已增至约1.4万人.佳丽宝方面透露,截至9月29 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.036 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
